<template>
    <div :class="toggleMenu ? 'app-menu' : 'app-menu app-menu-translate'">
        <span @click="onToggleMenu" class="toggle-menu" v-html="toggleMenuHtml"></span>
        <p @click="$router.push({name: 'home'}).catch(err => {})" class="title-white">APP<br>WEBSANDBOX</p>
        <div class="divider"></div>
        <div class="menu">
            <router-link :to="{name: 'home'}" exact class="nav-bar-item nav-bar-text">Home</router-link>
            <router-link :to="{name: 'account'}" exact class="nav-bar-item nav-bar-text">Account</router-link>
            <router-link :to="{name: 'dashboardUser'}" class="nav-bar-item nav-bar-text">Projects</router-link>
            <div class="nav-bar-item nav-bar-text" @click="redirectToClient">Websandbox</div>
        </div>
        <div v-if="(this.user.role_app==='admin')" class="divider"></div>
        <div v-if="(this.user.role_app==='admin')" class="menu">
            <div class="admin-title">Admin</div>
            <router-link :to="{name: 'dashboardAdminUsers'}" v-if="(this.user.role_app==='admin')" class="nav-bar-item nav-bar-item-admin nav-bar-text">Manage Users</router-link>
            <router-link :to="{name: 'dashboardAdminProjects'}" v-if="(this.user.role_app==='admin')" class="nav-bar-item nav-bar-item-admin nav-bar-text">Manage Projects</router-link>
        </div>
        <div class="divider"></div>
        <div class="info-account">
            <img src="../assets/svg/avatar.svg" alt="avatar" class="avatar">
            
            <p class="text-light">{{ user.username }}<br>{{ user.email }}</p>
        <div v-if="user"> 
            <p>Pack : {{user.account_type}}</p>
        </div>
        <div v-if="user.account_type === 'free'">
            <a :href="clientUrl + '/pricing'" class="btn">Upgrade</a>
        </div>
        <div v-else >
            <button class="btn" @click="unsubscribe">Unsubscribe</button>
        </div>
        </div>
        <div class="divider"></div>
        <a href="/" class="btn" @click="logout()">
            Log out
        </a>
    </div>
</template>

<script>
import store from '../config/store'
import Vuex, { mapActions } from 'vuex'
import { io } from 'socket.io-client';

export default {
    name: 'Header',
    store: store,
    data() {
        return {
            clientUrl: process.env.VUE_APP_CLIENT_URL,
            toggleMenu: true,
            toggleMenuHtml: '&#8249;',
            apiURL: process.env.VUE_APP_API_URL,
            appUrl: process.env.VUE_APP_URL

        }
    },

    methods: {
        ...mapActions([
            'setSocket',
            'getUserProjects',
            'checkToken'
        ]),
        onToggleMenu: function() {
            this.toggleMenu = this.toggleMenu ? false : true;
            this.toggleMenuHtml = this.toggleMenu ? '&#8249;' : '&#8250;'
        },
        redirectToClient: function() {
            window.location.href = this.clientUrl;
        },
        unsubscribe() {
            fetch(process.env.VUE_APP_API_URL+'/stripe/subcription_cancel', {
                headers: {
                    'Content-Type': 'application/json'
                },
                method: 'POST',
                body: JSON.stringify({email: this.user.email})
            }).then(() => {
                this.checkToken(localStorage.getItem('user-token'))
            })
        },
        logout() {
            localStorage.removeItem('user-token');
            const user = {
                token: '',
                isConnected: false,
            }
            fetch(process.env.VUE_APP_API_URL+'/users/' + this.$props.id, {
                headers: {
                    'Content-Type': 'application/json'
                },
                method: 'PUT',
                body: JSON.stringify({ user: user })
            })
        }        
    },
    computed: {
        ...Vuex.mapGetters([
            'user',
            'socket',
        ]),
    },
    created() {
        this.getUserProjects(this.user.id)
        const socket = io(process.env.VUE_APP_API_URL);
        this.setSocket(socket)
        this.socket.emit('setup', {user: this.user})
    },
}
</script>

<style scoped>
    .app-menu {
        position: relative;
        padding: 20px 0;
        width: 240px;
        min-width: 240px;
        display: flex;
        background: url('../assets/svg/menu.svg');
        flex-direction: column;
        align-items: center;
        justify-content: flex-start;
        transition: 100ms;
        min-height:100vh;
    }

    .app-menu-translate {
        transition: 100ms;
        transform: translateX(-240px);
        position: absolute;
    }

    .toggle-menu {
        top: 15px;
        right: -20px;
        position: absolute;
        display: flex;
        align-items: center;
        justify-content: center;
        height: 35px;
        width: 10px;
        padding: 20px 10px;
        background: #000550;
        border-radius: 0 5px 5px 0;
        cursor: pointer;
        outline: none;
    }

    .toggle-menu:hover {
        transition: 200ms ease;
        background-color: white;
        color: #000550;
    }

    .router-link-active {
        color: white;
        text-decoration: none;
    }

    .nav-bar-text {
        cursor: pointer;
    }

    .nav-bar-text.router-link-active {
        color: var(--color-light);
        font-weight: 700 !important;
    }

    .title-white {
        font-size: 24px;
        cursor: pointer;
        user-select: none;
    }

    .divider {
        border-top: solid 1px white;
        height: 1px;
        width: 240px;
        margin: 20px 0;
    }

    .menu {
        padding: 15px 30px 15px 50px;
        width: 100%;
        display: flex;
        flex-direction: column;
        align-items: flex-start;
        justify-content: flex-start;
    }

    .menu .nav-bar-item {
        font-size: 18px;
        text-decoration: none;
        font-weight: 300;
        color: white;
        margin-bottom: 20px;
    }

    .menu .nav-bar-item:last-child {
        margin-bottom: 0 !important;
    }

    .router-link-active {
        font-weight: 700;
    }

    .info-account {
        padding: 20px 0;
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: flex-start;
    }

    .avatar {
        width: 90px;
    }

    .navbar-admin-parent {
        margin-bottom:8px !important;
    }

    .admin-title {
        font-weight: 800;
        font-size: 18px;
        color: var(--color-primary-pink);
        margin-bottom: 15px;
    }

    .nav-bar-item-admin {
        padding-left: 8px;
    }
</style>
